(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@ngrx/store')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@ngrx/store'], factory) :
	(factory((global.ng = global.ng || {}, global.ng.interceptor = {}),global.ng.core,global.ng.store));
}(this, (function (exports,core,store) { 'use strict';

var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var InterceptorModule = (function () {
    function InterceptorModule() {
    }
    InterceptorModule.forRoot = function (permissible) {
        return {
            ngModule: InterceptorModule,
            providers: [
                { provide: store.Store, useClass: Interceptor },
                { provide: PermissionsProvider, useClass: permissible },
            ]
        };
    };
    InterceptorModule.decorators = [
        { type: core.NgModule },
    ];
    /** @nocollapse */
    InterceptorModule.ctorParameters = function () { return []; };
    return InterceptorModule;
}());
var PermissionsProvider = (function () {
    function PermissionsProvider() {
    }
    PermissionsProvider.prototype.canDoAction = function (action) {
        return true;
    };
    PermissionsProvider.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    PermissionsProvider.ctorParameters = function () { return []; };
    return PermissionsProvider;
}());
var Interceptor = (function (_super) {
    __extends(Interceptor, _super);
    function Interceptor(state$, actionsObserver, reducerManager, permissionsProvider) {
        var _this = _super.call(this, state$, actionsObserver, reducerManager) || this;
        _this.permissionsProvider = permissionsProvider;
        return _this;
    }
    Interceptor.prototype.dispatch = function (action) {
        if (this.permissionsProvider.canDoAction(action)) {
            _super.prototype.dispatch.call(this, action);
        }
    };
    Interceptor.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    Interceptor.ctorParameters = function () { return [
        { type: store.StateObservable, },
        { type: store.ActionsSubject, },
        { type: store.ReducerManager, },
        { type: PermissionsProvider, },
    ]; };
    return Interceptor;
}(store.Store));

// Public classes.

exports.InterceptorModule = InterceptorModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
