import { ModuleWithProviders, Type } from '@angular/core';
import { Action, ActionsSubject, ReducerManager, StateObservable, Store } from '@ngrx/store';
export interface ICanDoAction {
    canDoAction(action: Action): boolean;
}
export declare class InterceptorModule {
    static forRoot(permissible: Type<ICanDoAction>): ModuleWithProviders;
}
export declare class PermissionsProvider implements ICanDoAction {
    canDoAction(action: Action): boolean;
}
export declare class Interceptor<T> extends Store<T> {
    private permissionsProvider;
    constructor(state$: StateObservable, actionsObserver: ActionsSubject, reducerManager: ReducerManager, permissionsProvider: PermissionsProvider);
    dispatch(action: Action): void;
}
