var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Injectable, NgModule } from '@angular/core';
import { ActionsSubject, ReducerManager, StateObservable, Store } from '@ngrx/store';
var InterceptorModule = (function () {
    function InterceptorModule() {
    }
    InterceptorModule.forRoot = function (permissible) {
        return {
            ngModule: InterceptorModule,
            providers: [
                { provide: Store, useClass: Interceptor },
                { provide: PermissionsProvider, useClass: permissible },
            ]
        };
    };
    InterceptorModule.decorators = [
        { type: NgModule },
    ];
    /** @nocollapse */
    InterceptorModule.ctorParameters = function () { return []; };
    return InterceptorModule;
}());
export { InterceptorModule };
var PermissionsProvider = (function () {
    function PermissionsProvider() {
    }
    PermissionsProvider.prototype.canDoAction = function (action) {
        return true;
    };
    PermissionsProvider.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    PermissionsProvider.ctorParameters = function () { return []; };
    return PermissionsProvider;
}());
export { PermissionsProvider };
var Interceptor = (function (_super) {
    __extends(Interceptor, _super);
    function Interceptor(state$, actionsObserver, reducerManager, permissionsProvider) {
        var _this = _super.call(this, state$, actionsObserver, reducerManager) || this;
        _this.permissionsProvider = permissionsProvider;
        return _this;
    }
    Interceptor.prototype.dispatch = function (action) {
        if (this.permissionsProvider.canDoAction(action)) {
            _super.prototype.dispatch.call(this, action);
        }
    };
    Interceptor.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    Interceptor.ctorParameters = function () { return [
        { type: StateObservable, },
        { type: ActionsSubject, },
        { type: ReducerManager, },
        { type: PermissionsProvider, },
    ]; };
    return Interceptor;
}(Store));
export { Interceptor };
//# sourceMappingURL=interceptor.module.js.map